config/routes.rb
Rails.application.routes.draw do
  resources :carts
  devise_for :users
  resources :customers
  resources :spectacles
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  #root "customers#index"
  root "pages#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cart.rb
class Cart < ApplicationRecord
  belongs_to :customer
end

app/models/customer.rb
class Customer < ApplicationRecord

end

app/models/frame.rb
class Frame < ApplicationRecord
  belongs_to :spectacle
end

app/models/lense.rb
class Lense < ApplicationRecord
  belongs_to :spectacle
end

app/models/spectacle.rb
class Spectacle < ApplicationRecord
  has_many :lenses, dependent: :destroy
  has_many :frames, dependent: :destroy
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/carts_controller.rb
class CartsController < ApplicationController
  before_action :set_cart, only: %i[ show edit update destroy ]

  # GET /carts or /carts.json
  def index
    @carts = Cart.all
  end

  # GET /carts/1 or /carts/1.json
  def show
  end

  # GET /carts/new
  def new
    @cart = Cart.new
  end

  # GET /carts/1/edit
  def edit
  end

  # POST /carts or /carts.json
  def create
    @cart = Cart.new(cart_params)

    respond_to do |format|
      if @cart.save
        format.html { redirect_to @cart, notice: "Cart was successfully created." }
        format.json { render :show, status: :created, location: @cart }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /carts/1 or /carts/1.json
  def update
    respond_to do |format|
      if @cart.update(cart_params)
        format.html { redirect_to @cart, notice: "Cart was successfully updated." }
        format.json { render :show, status: :ok, location: @cart }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /carts/1 or /carts/1.json
  def destroy
    @cart.destroy
    respond_to do |format|
      format.html { redirect_to carts_url, notice: "Cart was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cart
      @cart = Cart.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def cart_params
      params.require(:cart).permit(:item, :quantity, :cart_value, :customer_id)
    end
end

app/controllers/customers_controller.rb
require "fileutils"

class CustomersController < ApplicationController
  before_action :set_customer, only: %i[ show edit update destroy ]
  #  before_action :authenticate_user!

  # GET /customers or /customers.json
  def index
    @customers = Customer.all.order(created_at: :desc)
    #@items = Item.all
    respond_to do |format|
      format.xlsx {
        response.headers[
          "Content-Disposition"
        ] = "attachment; filename='customers.xlsx'"
      }
      format.html { render :index }
    end
    #FileUtils.touch("index.xlsx.axlsx")

  end

  # GET /customers/1 or /customers/1.json
  def show
  end

  # GET /customers/new
  def new
    @customer = Customer.new
  end

  # GET /customers/1/edit
  def edit
  end

  # POST /customers or /customers.json
  def create
    @customer = Customer.new(customer_params)

    respond_to do |format|
      if @customer.save
        format.html { redirect_to @customer, notice: "Customer was successfully created." }
        format.json { render :show, status: :created, location: @customer }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @customer.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /customers/1 or /customers/1.json
  def update
    respond_to do |format|
      if @customer.update(customer_params)
        format.html { redirect_to @customer, notice: "Customer was successfully updated." }
        format.json { render :show, status: :ok, location: @customer }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @customer.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /customers/1 or /customers/1.json
  def destroy
    @customer.destroy
    respond_to do |format|
      format.html { redirect_to customers_url, notice: "Customer was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_customer
    @customer = Customer.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def customer_params
    params.require(:customer).permit(:name, :address, :mobile, :email)
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def index
    @spects = Spectacle.all.order(created_at: :desc)
  end
end

app/controllers/spectacles_controller.rb
class SpectaclesController < ApplicationController
  before_action :set_spectacle, only: %i[show edit update destroy]

  def index
    @spects = Spectacle.all
  end

  def new
    @spect = Spectacle.new
  end

  def show
  end

  def create
    @spect = Spectacle.create(company: spects_params[:company], stype: spects_params[:stype])
    if @spect.save
      if Frame.create(spectacle_id: @spect.id, frame_type: spects_params[:frame_type], frame_price: spects_params[:frame_price]) and Lense.create(spectacle_id: @spect.id, lense_price: spects_params[:lense_price], lense_type: spects_params[:lense_type])
        redirect_to spectacles_path, notice: "Success"
      else
        redirect_to spectacles_path, notice: " Not success"
      end
    end
  end

  def destroy
    #@spect = Spectacle.find(params[:id])
    @spect.destroy
    redirect_to spectacles_path, notice: "Success"

    #redirect_to spectacles_path, notice: "Not Success"
  end

  def update
    if @spect.update(spects_params)
      redirect_to @spect, notice: "Success"
    else
      redirect_to @spect, notice: "Success"
    end
  end

  private

  def set_spectacle
    @spect = Spectacle.find(params[:id])
  end

  def spects_params
    params.require(:spectacle).permit(:company, :stype, :frame_type, :frame_price, :cylindrical, :spherical, :axis, :power, :lense_type, :lense_price)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/carts_helper.rb
module CartsHelper
end

app/helpers/customers_helper.rb
module CustomersHelper
end

app/helpers/spects_helper.rb
module SpectsHelper
end

app/views/carts/_form.html.erb
<%= form_with(model: cart, local: true) do |form| %>
  <% if cart.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(cart.errors.count, "error") %> prohibited this cart from being saved:</h2>

      <ul>
        <% cart.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :item %>
    <%= form.text_field :item %>
  </div>

  <div class="field">
    <%= form.label :quantity %>
    <%= form.number_field :quantity %>
  </div>

  <div class="field">
    <%= form.label :cart_value %>
    <%= form.text_field :cart_value %>
  </div>

  <div class="field">
    <%= form.label :customer_id %>
    <%= form.text_field :customer_id %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/carts/edit.html.erb
<h1>Editing Cart</h1>

<%= render 'form', cart: @cart %>

<%= link_to 'Show', @cart %> |
<%= link_to 'Back', carts_path %>

app/views/carts/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Carts</h1>

<table>
  <thead>
    <tr>
      <th>Item</th>
      <th>Quantity</th>
      <th>Cart value</th>
      <th>Customer</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @carts.each do |cart| %>
      <tr>
        <td><%= cart.item %></td>
        <td><%= cart.quantity %></td>
        <td><%= cart.cart_value %></td>
        <td><%= cart.customer_id %></td>
        <td><%= link_to 'Show', cart %></td>
        <td><%= link_to 'Edit', edit_cart_path(cart) %></td>
        <td><%= link_to 'Destroy', cart, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Cart', new_cart_path %>

app/views/carts/new.html.erb
<h1>New Cart</h1>

<%= render 'form', cart: @cart %>

<%= link_to 'Back', carts_path %>

app/views/carts/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Item:</strong>
  <%= @cart.item %>
</p>

<p>
  <strong>Quantity:</strong>
  <%= @cart.quantity %>
</p>

<p>
  <strong>Cart value:</strong>
  <%= @cart.cart_value %>
</p>

<p>
  <strong>Customer:</strong>
  <%= @cart.customer_id %>
</p>

<%= link_to 'Edit', edit_cart_path(@cart) %> |
<%= link_to 'Back', carts_path %>

app/views/customers/_form.html.erb
<%= form_with(model: customer, local: true) do |form| %>
  <% if customer.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(customer.errors.count, "error") %> prohibited this customer from being saved:</h2>
      <ul>
        <% customer.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>
  <div class="field">
    <%= form.label :address %>
    <%= form.text_area :address %>
  </div>
  <div class="field">
    <%= form.label :mobile_no %>
    <%= form.text_field :mobile_no %>
  </div>
  <div class="field">
    <%= form.label :email %>
    <%= form.text_field :email %>
  </div>
  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/customers/edit.html.erb
    <h1>Editing Customer</h1>

<%= render 'form', customer: @customer %>

<%= link_to 'Show', @customer %> |
<%= link_to 'Back', customers_path %>

app/views/customers/index.html.erb
<p id="notice"><%= notice %></p>
<% if user_signed_in? %>
  <%= link_to "logout", destroy_user_session_path, method: :delete %>
<% else %>
  <%= link_to "login", user_session_path%>
<% end %>
<h1>Customers</h1>
<%= link_to 'New Customer', new_customer_path %> &nbsp &nbsp &nbsp &nbsp
<%=link_to 'Download as Excel',customers_path(format: :xlsx)%>
<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Address</th>
      <th>Mobile no</th>
      <th>Email</th>
      <th>Actions</th>
      <th colspan="3"></th>
    </tr>
  </thead>
  <tbody>
    <% @customers.each do |customer| %>
      <tr>
        <td><%= customer.name %></td>
        <td><%= customer.address %></td>
        <td><%= customer.mobile_no %></td>
        <td><%= customer.email %></td>
        <td><%= link_to 'Show', customer %></td>
        <td><%= link_to 'Edit', edit_customer_path(customer) %></td>
        <td><%= link_to 'Destroy', customer, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>
<br>

app/views/customers/new.html.erb
<h1>New Customer</h1>

<%= render 'form', customer: @customer %>

<%= link_to 'Back', customers_path %>

app/views/customers/show.html.erb
<p id="notice"><%= notice %></p>
<p>
  <strong>Name:</strong>
  <%= @customer.name %>
</p>
<p>
  <strong>Address:</strong>
  <%= @customer.address %>
</p>
<p>
  <strong>Mobile no:</strong>
  <%= @customer.mobile_no %>
</p>
<p>
  <strong>Email:</strong>
  <%= @customer.email %>
</p>
<%= link_to 'Edit', edit_customer_path(@customer) %> |
<%= link_to 'Back', customers_path %>

app/views/layouts/_footer.html.erb
<!-- Footer -->
<footer class="bg-dark text-center text-white">
  <!-- Grid container -->
  <div class="container p-4">
    <!-- Section: Social media -->
    <section class="mb-4">
      <!-- Facebook -->
      <a class="btn btn-outline-light btn-floating m-1" href="#!" role="button"
        ><i class="fab fa-facebook-f"></i
      ></a>
      <!-- Twitter -->
      <a class="btn btn-outline-light btn-floating m-1" href="#!" role="button"
        ><i class="fab fa-twitter"></i
      ></a>
      <!-- Google -->
      <a class="btn btn-outline-light btn-floating m-1" href="#!" role="button"
        ><i class="fab fa-google"></i
      ></a>
      <!-- Instagram -->
      <a class="btn btn-outline-light btn-floating m-1" href="#!" role="button"
        ><i class="fab fa-instagram"></i
      ></a>
      <!-- Linkedin -->
      <a class="btn btn-outline-light btn-floating m-1" href="#!" role="button"
        ><i class="fab fa-linkedin-in"></i
      ></a>
      <!-- Github -->
      <a class="btn btn-outline-light btn-floating m-1" href="#!" role="button"
        ><i class="fab fa-github"></i
      ></a>
    </section>
    <!-- Section: Social media -->
    <!-- Section: Form -->
    <section class="">
      <form action="">
        <!--Grid row-->
        <div class="row d-flex justify-content-center">
          <!--Grid column-->
          <div class="col-auto">
            <p class="pt-2">
              <strong>Sign up for our newsletter</strong>
            </p>
          </div>
          <!--Grid column-->
          <!--Grid column-->
          <div class="col-md-5 col-12">
            <!-- Email input -->
            <div class="form-outline form-white mb-4">
              <input type="email" id="form5Example2" class="form-control" />
              <label class="form-label" for="form5Example2">Email address</label>
            </div>
          </div>
          <!--Grid column-->
          <!--Grid column-->
          <div class="col-auto">
            <!-- Submit button -->
            <button type="submit" class="btn btn-outline-light mb-4">
              Subscribe
            </button>
          </div>
          <!--Grid column-->
        </div>
        <!--Grid row-->
      </form>
    </section>
    <!-- Section: Form -->
    <!-- Section: Text -->
    <section class="mb-4">
      <p>
        Lorem ipsum dolor sit amet consectetur adipisicing elit. Sunt distinctio earum
        repellat quaerat voluptatibus placeat nam, commodi optio pariatur est quia magnam
        eum harum corrupti dicta, aliquam sequi voluptate quas.
      </p>
    </section>
    <!-- Section: Text -->
    <!-- Section: Links -->
    <section class="">
      <!--Grid row-->
      <div class="row">
        <!--Grid column-->
        <div class="col-lg-3 col-md-6 mb-4 mb-md-0">
          <h5 class="text-uppercase">Links</h5>
          <ul class="list-unstyled mb-0">
            <li>
              <a href="#!" class="text-white">Link 1</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 2</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 3</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 4</a>
            </li>
          </ul>
        </div>
        <!--Grid column-->
        <!--Grid column-->
        <div class="col-lg-3 col-md-6 mb-4 mb-md-0">
          <h5 class="text-uppercase">Links</h5>
          <ul class="list-unstyled mb-0">
            <li>
              <a href="#!" class="text-white">Link 1</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 2</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 3</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 4</a>
            </li>
          </ul>
        </div>
        <!--Grid column-->
        <!--Grid column-->
        <div class="col-lg-3 col-md-6 mb-4 mb-md-0">
          <h5 class="text-uppercase">Links</h5>
          <ul class="list-unstyled mb-0">
            <li>
              <a href="#!" class="text-white">Link 1</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 2</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 3</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 4</a>
            </li>
          </ul>
        </div>
        <!--Grid column-->
        <!--Grid column-->
        <div class="col-lg-3 col-md-6 mb-4 mb-md-0">
          <h5 class="text-uppercase">Links</h5>
          <ul class="list-unstyled mb-0">
            <li>
              <a href="#!" class="text-white">Link 1</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 2</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 3</a>
            </li>
            <li>
              <a href="#!" class="text-white">Link 4</a>
            </li>
          </ul>
        </div>
        <!--Grid column-->
      </div>
      <!--Grid row-->
    </section>
    <!-- Section: Links -->
  </div>
  <!-- Grid container -->
  <!-- Copyright -->
  <div class="text-center p-3" style="background-color: rgba(0, 0, 0, 0.2);">
    © 2020 Copyright:
    <a class="text-white" href="https://mdbootstrap.com/">MDBootstrap.com</a>
  </div>
  <!-- Copyright -->
</footer>
<!-- Footer -->

app/views/layouts/_header.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <!--<a class="navbar-brand" href="#">Navbar</a>-->
  <%=link_to root_path, class:"navbar-brand" do  %>
    <i class="fa fa-home" aria-hidden="true"></i>
  <%end%>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="#">Link</a>
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Dropdown
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="#">Action</a>
          <a class="dropdown-item" href="#">Another action</a>
          <div class="dropdown-divider"></div>
          <a class="dropdown-item" href="#">Something else here</a>
        </div>
      </li>
      <li class="nav-item">
        <a class="nav-link disabled" href="#">Disabled</a>
      </li>
    </ul>
    <form class="form-inline my-2 my-lg-0">
      <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
    </form>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Saioptics</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <meta name="viewport" content="width=device-width, initial-scale=1">
  </head>
  <body>
    <header><%= render 'layouts/header' %></header>
    <div>
      <p class="notice"><%= notice %></p>
      <p class="alert"><%= alert %></p>
    </div>
    <div class= "container">
      <%= yield %>
    </div>
    <footer><%= render 'layouts/footer' %></footer>
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
  </body>
</html>

app/views/pages/index.html.erb
<%@spects.each do |spec|%>
  <%=spec.company%><br>
<%end%>

app/views/spectacles/_spects_form.html.erb
<%= form_with(model:spectacle, local: true) do |form|%>
  <%=form.text_field :company, placeholder: "company"%>
  <%=form.text_field :stype, placeholder: "spectacle_type"%> <br>
  <br>
  <%=form.text_field :frame_type, placeholder: "frame type"%>
  <%=form.text_field :frame_price, placeholder:"frame price"%><br>
  <br>
  <%=form.text_field :cylindrical, placeholder: "cylindrical"%>
  <%=form.text_field :spherical, placeholder:"spherical"%>
  <%=form.text_field :axis, placeholder: "axis"%>
  <%=form.text_field :power, placeholder:"power"%><br>
  <br>
  <%=form.text_field :lense_type, placeholder:"lense type"%>
  <%=form.text_field :lense_price, placeholder:"lense price"%>
  <%=form.submit "Add"%>
<%end%>

app/views/spectacles/edit.html.erb
<%= render 'spects_form', spectacle: @spect %>
<%= link_to "Back", spectacles_path%>

app/views/spectacles/index.html.erb
<%= render 'spects_form', spectacle: @spect %>
<table>
  <thead>
    <tr>
      <th>company</th>
      <th>type</th>
      <th>frame type </th>
      <th colspan="3"></th>
    </tr>
  </thead>
  <tbody>
    <% @spects.each do |spect| %>
      <tr>
        <td><%= spect.company %></td>
        <td><%= link_to 'Show', spect %></td>
        <td><%= link_to 'Edit', edit_spectacle_path(spect) %></td>
        <td><%= link_to 'Destroy', spect, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/spectacles/show.html.erb
<br>
<%= link_to "Back", spectacles_path%>
<br>
<br>
<p><%=@spect.company%> <br>
  <%=@spect.stype%>  </p>
<%@spect.frames.each do |spect_frame|%>
  <%=spect_frame.frame_type%><br>
  <%=spect_frame.frame_price%>
<%end%><br>
<br>
<%@spect.lenses.each do |spect_lense|%>
  <%=spect_lense.lense_type%><br>
  <%=spect_lense.lense_price%>
<%end%>